/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// File de priorité (contenant des entiers)

// la capacité est ici limitée (à la valeur `capacity` passée à `create`)

#include "prelude.h"

#ifndef PQUEUE
#define PQUEUE

typedef struct Pqueue pqueue;

pqueue *pqueue_create(int capacity);
int pqueue_size(pqueue *q);
bool pqueue_is_empty(pqueue *q);
bool pqueue_is_full(pqueue *q);

void pqueue_add(pqueue *q, int x);
  // O(log n)
int pqueue_min(pqueue *q);
  // O(1)
int pqueue_remove_min(pqueue *q);
  // O(log n)

pqueue *pqueue_of_array(int a[], int n);
  // O(n)

void pqueue_delete(pqueue *q);

#endif
